#include "Tree.h"


Tree::Tree(string first,string second,int select){
	head = NULL;
	possible = 1;

	checker(first,second);
	firstCheck(first);
	firstCheck(second);

	switch(select){
	case 1:
		try{
			infixed = first;
			prefixed = second;

			head = makeFromIn_Pre(first,second);
		}catch(Except & e){
			delete4des(head);
			head = NULL;
			throw;
		}
		postfixed = postfixer(head);
		break;

	case 2:
		infixed = first;
		postfixed = second;

		try{
			head = makeFromIn_Post(first,second);
		}catch(Except & e){
			delete4des(head);
			head = NULL;
			throw;
		}
		prefixed = prefixer(head);
		break;

	case 3:
		postfixed = first;
		prefixed = second;

		try{
			head = makeFromPost_Pre(first,second);
		}catch(Except & e){
			delete4des(head);
			head = NULL;
			throw;
		}
		infixed = infixer(head);
		break;
	}
}

Tree::~Tree(){
	delete4des(head);
}

void Tree::delete4des(Node * where2del){
	if(where2del == NULL)
		return;

	delete4des(where2del->right);
	where2del->right = NULL;
	delete4des(where2del->left);
	where2del->left = NULL;
	delete where2del;
}

void Tree::checker(string first,string second){
	if(first.length() != second.length())
		throw Except("ERR : Two strings must be comaptible!!");

	if(first.length() == 0)
		throw Except("ERR : Strings must have value!!");

	int end = first.length();

	for(int count = 0;count < end;count++){
		if(first.find(second[count]) == -1)
			throw Except("ERR : Two strings must be compatible!!");
	}
}

Node * Tree::makeFromIn_Post(string infix, string postfix)
{
	checker(infix,postfix);

	if(infix.length() == 1)//BASE CASE
		return new Node(infix[0]);

	string tempin,temppost;//TEMP STRINGS FOR STRING MANUPOLATION

	int where = infix.find(postfix[postfix.length() - 1]);//FIND THE ROOT

	Node * root = new Node(postfix[postfix.length() - 1]);//ROOT

	//LEFT SUBTREE
	tempin = string(infix, 0, where);
	temppost = string(postfix, 0, where);

	if(tempin.length() == 0)
		root->left = NULL;
	else
		root->left = makeFromIn_Post(tempin, temppost);

	//RIGHT SUBTREE
	tempin = string(infix, where + 1, infix.length() - where - 1);
	temppost = string(postfix, where, postfix.length() - where - 1);

	if(tempin.length() == 0)
		root->right = NULL;
	else
		root->right = makeFromIn_Post(tempin, temppost);	

	return root;
}


Node * Tree::makeFromIn_Pre(string infix, string prefix)
{
	checker(infix,prefix);

	if(infix.length() == 1)//BASE CASE
		return new Node(infix[0]);

	string tempin,temppre;//TEMP STRINGS FOR STRING MANUPOLATION

	int where = infix.find(prefix[0]);//FIND THE ROOT

	Node * root = new Node(prefix[0]);//ROOT

	//LEFT SUBTREE
	tempin = string(infix, 0, where);
	temppre = string(prefix, 1, where);

	if(tempin.length() == 0)
		root->left = NULL;
	else
		root->left = makeFromIn_Pre(tempin, temppre);

	//RIGHT SUBTREE
	tempin = string(infix, where + 1, infix.length() - where - 1);
	temppre = string(prefix, where + 1, prefix.length() - where - 1);

	if(tempin.length() == 0)
		root->right = NULL;
	else
		root->right = makeFromIn_Pre(tempin, temppre);	

	return root;
}


Node * Tree::makeFromPost_Pre(string postfix, string prefix)
{
	checker(postfix,prefix);

	if(prefix.length() == 1)//BASE CASE
		return new Node(prefix[0]);

	string temppre,temppost;//TEMP STRINGS FOR STRING MANUPOLATION

	int where = postfix.find(prefix[1]);//FIND THE ROOT

	Node * root = new Node(prefix[0]);//ROOT

	//LEFT SUBTREE
	temppre = string(prefix, 1, where + 1);
	temppost = string(postfix, 0, where + 1);

	if(temppre.length() == 0)
		root->left = NULL;
	else
		root->left = makeFromPost_Pre(temppost, temppre);

	//RIGHT SUBTREE
	temppre = string(prefix, where + 2, prefix.length() - where - 2);
	temppost = string(postfix, where + 1, postfix.length() - where - 2);

	if(temppre.length() == 0)
		root->right = NULL;
	else
		root->right = makeFromPost_Pre(temppost, temppre);	

	if((root->right == NULL && root->left != NULL) || (root->right != NULL && root->left == NULL))
		possible *= 2;

	return root;
}

string Tree::postfixer(Node * where2print){
	if(where2print == NULL)
		return "";
	string gone;

	if(where2print->left != NULL)
		gone += postfixer(where2print->left);

	if(where2print->right != NULL)
		gone += postfixer(where2print->right);

	gone += where2print->data;

	return gone;
}

string Tree::prefixer(Node * where2print){
	if(where2print == NULL)
		return "";
	string gone;

	gone += where2print->data;

	if(where2print->left != NULL)
		gone += prefixer(where2print->left);

	if(where2print->right != NULL)
		gone += prefixer(where2print->right);

	return gone;
}

string Tree::infixer(Node * where2print){
	if(where2print == NULL)
		return "";
	string gone;

	if(where2print->left != NULL)
		gone += infixer(where2print->left);

	gone += where2print->data;

	if(where2print->right != NULL)
		gone += infixer(where2print->right);

	return gone;
}

void Tree::firstCheck(string first){
	int end = first.length(),number;
	char mychar;
	
	for(int count = 0;count < end;count++){
		number = 0;
		mychar = first[count];

//		if( mychar == '+' ||  mychar == '-' ||  mychar == '*' ||  mychar == '/')
//			continue;

		for(int i = 0;i < end;i++){
			if(first[i] == mychar)
				number++;
		}

		if(number != 1)
			throw Except("ERR : The value of two nodes must be different!!");
	}
}